; =================== Interrupts =====================
NMI:
	lda #$00
	sta OAMADDR			; set the low byte (00) of the RAM address
	lda #$02			; copy sprite data from $0200 => PPU memory for display
    sta OAMDMA
  ; This is the PPU clean up section, so rendering the next frame starts properly.
    lda #%10001000		; turn on nmi interrupt
	sta PPUCTRL
	lda #%00011110		; turn on the screen
	sta PPUMASK
	lda #$00			; clear scrolling registers for stable top of screen 
	sta PPUSCROLL
	sta PPUSCROLL

WaitSprite0NotHit:
	lda $2002
	and #%01000000
	bne WaitSprite0NotHit	; wait until sprite 0 not hit

WaitSprite0Hit:
	lda $2002
	and #%01000000
	bne WaitSprite0Hit  ; wait until sprite 0 not hit

	ldx #$10
WaitScanline:
	dex
	bne WaitScanline

	lda scrollx
	sta PPUSCROLL		; write the horizontal scroll count register
	lda #$00			; no vertical scrolling
	sta PPUSCROLL
; scroll registers were touched so clean up PPU
    lda #%10001000		; turn on nmi interrupt
	sta PPUCTRL

	jsr ReadPad			; read the controller

	jsr UpdateSprites	; update the sprites
	jsr UpdateScrolling	; update scrolling
	rti