		.include "include/equ.asm"
		.include "include/header.asm"
		.include "game/zeropage.asm"
		.include "game/ram.asm"
		.include "include/init.asm"
; =============== Start of game code =================

Start:
	jsr LoadPalette		; load palette
	lda #<GameBackgroundNametable
	sta pointerLo       ; put the low byte of the address of background into pointer
	lda #>GameBackgroundNametable
	sta pointerHi       ; put the high byte of the address into pointer
	jsr LoadNametable	; load game background
	jsr LoadSprites		; load the sprites
	lda #%10001000		; turn on nmi interrupt
	sta PPUCTRL
	lda #%00011110		; turn on the screen
	sta PPUMASK
MainLoop:
	jmp MainLoop

; ==================== Interrupts ====================
	.include "include/interrupts.asm"

; =================== Subroutines ====================
	.segment "CODE"
	.include "include/ppu.asm"
	.include "game/sprite.asm"
	.include "game/update.asm"
	.include "include/pad.asm"

; ======================= Data =======================
	.segment "RODATA"
PaletteData:
	.include "game/palette.asm"
GameBackgroundNametable:
	.include "game/gamebackground_nametable.asm"
; ====================== Vectors =====================
	.include "include/vectors.asm"

	.segment "CHARS0"
	.include "game/backgroundtiles.asm"
	.segment "CHARS1"
	.include "game/spritetiles.asm"